

#ifndef _PARTICIO_HPP
#define _PARTICIO_HPP

#include <eda/error>
#include <eda/util>

using util::nat;

template <typename T>
class particio {
public:

  particio() throw(error);

  particio(const particio& p) throw(error);
  particio& operator=(const particio& p) throw(error);
  ~particio() throw();

  void afegir(const T& x) throw(error);

  void unir(const T& x, const T& y) throw(error);

  const T& representant(const T& x) const throw(error);

  nat size() const throw();

#ifdef EXTENDED_VERSION
  void print(ostream& os) const throw();
#endif

  static const char nom_mod[] = "particio";

  static const int ElemInexistent = 40;
  static const char MsgElemInexistent[]
                          = "L'element no pertany a la particio.";

private:
  #include "particio.rep"
};

#include "particio.t"
#endif
