

#ifndef _TESEUS_HPP
#define _TESEUS_HPP
#include <eda/error>
#include <eda/util>
#include <list>
#include <string>  
#include <utility>

using util::nat;

class laberint_teseus : public laberint {
public:

  explicit laberint_teseus(nat num_fil=5, nat num_col=5) throw(error);

  explicit laberint_teseus(istream& is) throw(error);

  void resoldre(const posicio& ini, const posicio& final,
                list<posicio>& L) throw(error);		

#ifdef EXTENDED_VERSION
  void resoldre(const posicio& ini, const posicio& final, ostream& os = std::cout) throw(error);
#endif

  static const char nom_mod[] = "laberint_teseus";

  static const int SenseSolucio   = 61;
  static const int IniciFiNoValid = 62;

  static const char MsgSenseSolucio[]
                          = "El laberint no te solucio";
  static const char MsgIniciFiNoValid[]
                          = "La cambra d'inici o de final no es valida.";
private:
	#include "teseus.rep"
};
#endif
